
/**
 * The class that is used to start the animator.
 *
 * The algorithms that are to be shown have to be added here.
 * 
 * @author Sara Stymne
 *
 */
public class AnimationStarter {
		
    public static void startSortAnimation() {
        
        //Creates an animator that places all algorithm
        //widgets on top of each other
        Animator animator = new Animator();
        
              
        //Adds algorithms to the system
        animator.addAlgorithm(new BubbleSortAlgorithm());
        //Add more algorithms here in the same way as for bubble sort
               
        //Must be called to show the main frame.
        animator.showFrame(); 
    }
    
	/**
	 * Main program for the animator. 
	 * The algorithms that are to be shown are added here.
	 * 
	 * @param args not used
	 */
	public static void main(String args[]) {
	    //Schedule a job for the event-dispatching thread:
	    //starting the animation, including showing the GUI
	    javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
            	AnimationStarter.startSortAnimation();
            }
        });
		    
	}

}
