
/**
 * Vector class that creates vectors that are sorted backwards
 * i.e. contains the integers from 1-size in decreasing order
 *
 * This class does not have to be changed.
 *
 * @author Sara Stymne
 *
 */
public class BackwardVector extends SortVector {

    /**
     * 
     */
    private static final long serialVersionUID = -4056015796480805125L;

    public BackwardVector() {
        super();
    }

    public BackwardVector(int size) {
        super(size, size);
        // TODO Auto-generated constructor stub
    }

    @Override
    public SortVector createNewInstance(int size, int max) {
        SortVector newVector = new BackwardVector(size);
        for(int i = newVector.size; i > 0; --i) {
            newVector.add(i);
        }
        return newVector;
    }

    @Override
    public SortVector clone() {
        SortVector copy = new BackwardVector(size);
        for(Integer i: this) {
            copy.add(i.intValue());
        }
        return copy;
    }

}
