
/**
 * Vector class that creates vectors that are sorted
 * i.e. contains the integers from 1-size in increasing order
 *
 * This class does not have to be changed.
 *
 * @author Sara Stymne
 *
 */
public class ForwardVector extends SortVector {

    /**
     * 
     */
    private static final long serialVersionUID = 5364327113189018764L;

    public ForwardVector() {
        super();
    }

    public ForwardVector(int size) {
        super(size, size);
    }

    @Override
    public SortVector createNewInstance(int size, int max) {
        SortVector newVector = new ForwardVector(size);
        for(int i = 1; i <= newVector.size; ++i) {
            newVector.add(i);
        }
        return newVector;
    }

    @Override
    public SortVector clone() {
        SortVector copy = new ForwardVector(size);
        for(Integer i: this) {
            copy.add(i.intValue());
        }
        return copy; 
    }

}
