
/**
 * Vector class that creates nearly sorted vectors 
 * it is created by filling a vector with integers 1-n in order,
 * and then randomly moving them a short distance (max 3 steps)
 *
 * This class does not have to be changed.
 *
 * @author Sara Stymne
 *
 */
public class NearlySortedVector extends SortVector {

    /**
     * 
     */
    private static final long serialVersionUID = -1497783217167490683L;

    public NearlySortedVector() {
        super();
    }

    public NearlySortedVector(int size) {
        super(size, size);
    }

  
    public SortVector createNewInstance(int size, int max) {
      SortVector newVector = new NearlySortedVector(size);    
      for(int i = 1; i <= newVector.size; i++) {
          newVector.add(i);
      }
      
      for(int i = 0; i < newVector.size; ++i) {
          int j = i + (int)(7 * Math.random()) - 3;
          if (j >= 0 && j < newVector.size())
              newVector.swap(i, j);
      }
      return newVector;
    }

    @Override
    public SortVector clone() {
        SortVector copy = new NearlySortedVector(size);
        for(Integer i: this) {
            copy.add(i.intValue());
        }
        return copy;
    }

}
