
/**
 * Vector class that creates vectors that are randomized,
 * i.e. contains random integers from 1 to max
 *
 * This class does not have to be changed.
 *
 * @author Sara Stymne
 *
 */
public class RandomVector extends SortVector {

    /**
     * 
     */
    private static final long serialVersionUID = -7931793733747970927L;

    public RandomVector() {
        super();
    }

    public RandomVector(int size, int max) {
        super(size, max);
    }

    @Override
    public SortVector createNewInstance(int size, int max) {
        SortVector newVector = new RandomVector(size, max);  
        for(int i = 1; i <= newVector.size; i++) {
            newVector.add((int)(Math.random()* newVector.max + 1));
        }
        return newVector;
    }

    @Override
    public SortVector clone() {
        SortVector copy = new RandomVector(size, max);
        for(Integer i: this) {
            copy.add(i.intValue());
        }
        return copy; 
    }

}
