
/**
 * Vector class that creates vectors that are scrambled,
 * i.e. contains the integers from 1-size in random order
 *
 * This class does not have to be changed.
 *
 * @author Sara Stymne
 *
 */
public class ScrambleVector extends SortVector {

    /**
     * 
     */
    private static final long serialVersionUID = -5356551972870952837L;

    public ScrambleVector() {
        super();
    }
    
    public ScrambleVector(int size) {
        super(size, size);
    }
    
    /* (non-Javadoc)
     * @see SortVector#createNewInstance()
     */
    @Override
    public SortVector createNewInstance(int size, int max) {
        SortVector newVector = new ScrambleVector(size);  
        for(int i = 1; i <= newVector.size; i++) {
            newVector.add(i);
        }
        
        for(int i = 0; i < newVector.size; ++i) {
            int j = (int)(newVector.size * Math.random());
            newVector.swap(i, j);
        }
        return newVector;
    }
    
    /** 
     * Returns a copy of the vector
     * 
     * @return the copy
     */
    public SortVector clone() {
        SortVector copy = new ScrambleVector(size);
        for(Integer i: this) {
            copy.add(i.intValue());
        }
        return copy;
    }
}
